package com.ruoyi.common.auth.wx;

import cn.binarywang.wx.miniapp.bean.WxMaPhoneNumberInfo;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.auth.wx.vo.WeChatMiniAuthorizeVo;
import com.ruoyi.common.config.WxConfig;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.http.HttpUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2024/7/29
 */
@Service
@Slf4j
public class WxAuthService {


    @Autowired
    private WxConfig wxConfig;

    public String getOpenId(String jsCode, String appId, String secret) {
        //根据jsCode换取openid
        String url = StrUtil.format("https://api.weixin.qq.com/sns/jscode2session?appid={}&secret={}&js_code={}&grant_type=authorization_code", appId, secret, jsCode);
        String s = HttpUtils.sendGet(url);
        WeChatMiniAuthorizeVo authorizeVo = JSONObject.parseObject(s, WeChatMiniAuthorizeVo.class);
        if (StringUtils.isEmpty(s) ) {
            throw new ServiceException("微信平台接口异常，没任何数据返回！");
        }
        return authorizeVo.getOpenid();
    }

    public String getPhoneNumber(String mobileCode, SysDept dept, String url) {
        /** 根据手机号获取到用户名*/
        String phoneNumber = null;
        String token = AccessTokenUtil.getToken(dept.getAppid(), dept.getAppSecret());
        url = url +token;
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("code", mobileCode);
        String post = HttpUtils.sendPost(url,jsonObject.toString());

        JSONObject jsonObject1 = JSONObject.parseObject(post);
        if(jsonObject1.getInteger("errcode")!=0){// 如果token无效则重新获取一次最新的token
            token = AccessTokenUtil.getForceRefreshToken(dept.getAppid(), dept.getAppSecret());
            url = url +token;
            post = HttpUtils.sendPost(url,jsonObject.toString());
            jsonObject1 = JSONObject.parseObject(post);
        }
        String phoneInfo = jsonObject1.getString("phone_info");
        WxMaPhoneNumberInfo wxMaPhoneNumberInfo = JSONObject.parseObject(phoneInfo, WxMaPhoneNumberInfo.class);
        if(StringUtils.isEmpty(wxMaPhoneNumberInfo.getPhoneNumber())){
            //重新获取一次token
            throw new ServiceException("凭证无效");
        }
        phoneNumber = wxMaPhoneNumberInfo.getPhoneNumber();
        return phoneNumber;
    }

}
